# find nearest neighbors for GP indiviuals

library(ggplot2);

gp_log <- read.csv2("C:/Users/P24581/filebox/GPTP 2018/symbreg-models-13.05.2018-1418.csv",header = FALSE,sep='\t',dec=',');
idx <- seq(1:nrow(gp_log));
# check popSize in gp_log
gp_log[seq(1,34000,500),1]
popSize <- 500;

# check qualities
# ggplot(gp_log, aes(x=idx,y=gp_log$V1)) + geom_line();

# generations <- seq(1,34000/popSize,1);
generations <- seq(1,15,1);
numClusters <- max(m$c);

gp_evals <- gp_log[,seq(3,202,2)];
all_evals <- m[,6:105];
for(gen_i in generations) {
#gen_i <- 15;
  selectedRows <- seq((gen_i - 1)*popSize + 1, gen_i * popSize,1); 
  min(selectedRows)
  max(selectedRows)
  xcorrel <- cor(t(all_evals[,]), t(gp_evals[selectedRows,]))^2
  mapped_gp_log <- m[max.col(t(xcorrel)), 1:5]
#check
#cor(t(all_evals[128082,]), t(gp_evals[2,]))^2
#max(cor(t(all_evals[,]), t(gp_evals[2,]))^2)
  ggplot(mapped_gp_log, aes(x=x, y=y)) + xlim(-75,75) + ylim(-75,75) + geom_point();
  ggsave(paste("scatter",gen_i,".png"))

  ggplot(mapped_gp_log, aes(x=c)) +xlim(0,numClusters+1) + geom_histogram(binwidth = 1);
  ggsave(paste("cluster_freq",gen_i,".png"))
}
